import{S as io,i as so,s as no,e as a,k as c,w as f,t as s,M as lo,c as o,d as t,m as d,a as i,x as h,h as n,b as m,N as po,f as mo,G as r,g as p,y as u,L as co,q as g,o as _,B as y,v as fo}from"../chunks/vendor-hf-doc-builder.js";import{I as J}from"../chunks/IconCopyLink-hf-doc-builder.js";import{C as K}from"../chunks/CodeBlock-hf-doc-builder.js";function ho(la){let A,sr,E,W,je,Q,qr,Ae,Ir,nr,F,Yr,Ee,Br,Rr,lr,C,S,Ce,X,Jr,xe,Kr,pr,b,Qr,Oe,Xr,Zr,Te,et,rt,Me,tt,at,mr,Z,cr,w,ot,Le,it,st,He,nt,lt,dr,ee,fr,x,V,De,re,pt,We,mt,hr,$,ct,te,dt,ft,ae,ht,ut,ur,oe,gr,z,gt,Fe,_t,yt,ie,vt,bt,se,zt,Pt,_r,ne,Se,pa,yr,O,N,Ve,le,wt,Ne,$t,vr,ve,kt,br,pe,zr,T,G,Ge,me,jt,Ue,At,Pr,be,Et,wr,ce,$r,M,U,qe,de,Ct,Ie,xt,kr,q,v,Ot,Ye,Tt,Mt,Be,Lt,Ht,Re,Dt,Wt,Je,Ft,St,Ke,Vt,Nt,Gt,L,Ut,Qe,qt,It,fe,Yt,Bt,jr,he,Ar,H,I,Xe,ue,Rt,Ze,Jt,Er,k,Kt,er,Qt,Xt,rr,Zt,ea,Cr,ge,xr,D,Y,tr,_e,ra,ar,ta,Or,j,aa,or,oa,ia,ir,sa,na,Tr,ye,Mr;return Q=new J({}),X=new J({}),Z=new K({props:{code:`import torch
from transformers import GPT2Tokenizer
from trl import PPOTrainer, PPOConfig, AutoModelForCausalLMWithValueHead

# 1. load a pretrained model
model = AutoModelForCausalLMWithValueHead.from_pretrained('gpt2')
model_ref = AutoModelForCausalLMWithValueHead.from_pretrained('gpt2')
tokenizer = GPT2Tokenizer.from_pretrained('gpt2')

# 2. define config
ppo_config = {'batch_size': 1, 'learning_rate':1e-5}
config = PPOConfig(**ppo_config)


# 2. Create optimizer
optimizer = torch.optim.SGD(model.parameters(), lr=config.learning_rate)


# 3. initialize trainer
ppo_trainer = PPOTrainer(config, model, model_ref, tokenizer, optimizer=optimizer)`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> GPT2Tokenizer
<span class="hljs-keyword">from</span> trl <span class="hljs-keyword">import</span> PPOTrainer, PPOConfig, AutoModelForCausalLMWithValueHead

<span class="hljs-comment"># 1. load a pretrained model</span>
model = AutoModelForCausalLMWithValueHead.from_pretrained(<span class="hljs-string">&#x27;gpt2&#x27;</span>)
model_ref = AutoModelForCausalLMWithValueHead.from_pretrained(<span class="hljs-string">&#x27;gpt2&#x27;</span>)
tokenizer = GPT2Tokenizer.from_pretrained(<span class="hljs-string">&#x27;gpt2&#x27;</span>)

<span class="hljs-comment"># 2. define config</span>
ppo_config = {<span class="hljs-string">&#x27;batch_size&#x27;</span>: <span class="hljs-number">1</span>, <span class="hljs-string">&#x27;learning_rate&#x27;</span>:<span class="hljs-number">1e-5</span>}
config = PPOConfig(**ppo_config)


<span class="hljs-comment"># 2. Create optimizer</span>
optimizer = torch.optim.SGD(model.parameters(), lr=config.learning_rate)


<span class="hljs-comment"># 3. initialize trainer</span>
ppo_trainer = PPOTrainer(config, model, model_ref, tokenizer, optimizer=optimizer)`}}),ee=new K({props:{code:`import torch
import bitsandbytes as bnb

from transformers import GPT2Tokenizer
from trl import PPOTrainer, PPOConfig, AutoModelForCausalLMWithValueHead

# 1. load a pretrained model
model = AutoModelForCausalLMWithValueHead.from_pretrained('gpt2')
model_ref = AutoModelForCausalLMWithValueHead.from_pretrained('gpt2')
tokenizer = GPT2Tokenizer.from_pretrained('gpt2')

# 2. define config
ppo_config = {'batch_size': 1, 'learning_rate':1e-5}
config = PPOConfig(**ppo_config)


# 2. Create optimizer
optimizer = bnb.optim.Adam8bit(model.parameters(), lr=config.learning_rate)

# 3. initialize trainer
ppo_trainer = PPOTrainer(config, model, model_ref, tokenizer, optimizer=optimizer)`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">import</span> bitsandbytes <span class="hljs-keyword">as</span> bnb

<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> GPT2Tokenizer
<span class="hljs-keyword">from</span> trl <span class="hljs-keyword">import</span> PPOTrainer, PPOConfig, AutoModelForCausalLMWithValueHead

<span class="hljs-comment"># 1. load a pretrained model</span>
model = AutoModelForCausalLMWithValueHead.from_pretrained(<span class="hljs-string">&#x27;gpt2&#x27;</span>)
model_ref = AutoModelForCausalLMWithValueHead.from_pretrained(<span class="hljs-string">&#x27;gpt2&#x27;</span>)
tokenizer = GPT2Tokenizer.from_pretrained(<span class="hljs-string">&#x27;gpt2&#x27;</span>)

<span class="hljs-comment"># 2. define config</span>
ppo_config = {<span class="hljs-string">&#x27;batch_size&#x27;</span>: <span class="hljs-number">1</span>, <span class="hljs-string">&#x27;learning_rate&#x27;</span>:<span class="hljs-number">1e-5</span>}
config = PPOConfig(**ppo_config)


<span class="hljs-comment"># 2. Create optimizer</span>
optimizer = bnb.optim.Adam8bit(model.parameters(), lr=config.learning_rate)

<span class="hljs-comment"># 3. initialize trainer</span>
ppo_trainer = PPOTrainer(config, model, model_ref, tokenizer, optimizer=optimizer)`}}),re=new J({}),oe=new K({props:{code:"",highlighted:`optimizer = Lion(<span class="hljs-built_in">filter</span>(<span class="hljs-keyword">lambda</span> p: p.requires_grad, self.model.parameters()), lr=self.config.learning_rate)

...
ppo_trainer = PPOTrainer(config, model, model_ref, tokenizer, optimizer=optimizer)`}}),le=new J({}),pe=new K({props:{code:`import torch
from transformers import GPT2Tokenizer
from trl import PPOTrainer, PPOConfig, AutoModelForCausalLMWithValueHead

# 1. load a pretrained model
model = AutoModelForCausalLMWithValueHead.from_pretrained('gpt2')
model_ref = AutoModelForCausalLMWithValueHead.from_pretrained('gpt2')
tokenizer = GPT2Tokenizer.from_pretrained('gpt2')

# 2. define config
ppo_config = {'batch_size': 1, 'learning_rate':1e-5}
config = PPOConfig(**ppo_config)


# 2. Create optimizer
optimizer = torch.optim.SGD(model.parameters(), lr=config.learning_rate)
lr_scheduler = lr_scheduler = torch.optim.lr_scheduler.ExponentialLR(optimizer, gamma=0.9)

# 3. initialize trainer
ppo_trainer = PPOTrainer(config, model, model_ref, tokenizer, optimizer=optimizer, lr_scheduler=lr_scheduler)`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> GPT2Tokenizer
<span class="hljs-keyword">from</span> trl <span class="hljs-keyword">import</span> PPOTrainer, PPOConfig, AutoModelForCausalLMWithValueHead

<span class="hljs-comment"># 1. load a pretrained model</span>
model = AutoModelForCausalLMWithValueHead.from_pretrained(<span class="hljs-string">&#x27;gpt2&#x27;</span>)
model_ref = AutoModelForCausalLMWithValueHead.from_pretrained(<span class="hljs-string">&#x27;gpt2&#x27;</span>)
tokenizer = GPT2Tokenizer.from_pretrained(<span class="hljs-string">&#x27;gpt2&#x27;</span>)

<span class="hljs-comment"># 2. define config</span>
ppo_config = {<span class="hljs-string">&#x27;batch_size&#x27;</span>: <span class="hljs-number">1</span>, <span class="hljs-string">&#x27;learning_rate&#x27;</span>:<span class="hljs-number">1e-5</span>}
config = PPOConfig(**ppo_config)


<span class="hljs-comment"># 2. Create optimizer</span>
optimizer = torch.optim.SGD(model.parameters(), lr=config.learning_rate)
lr_scheduler = lr_scheduler = torch.optim.lr_scheduler.ExponentialLR(optimizer, gamma=<span class="hljs-number">0.9</span>)

<span class="hljs-comment"># 3. initialize trainer</span>
ppo_trainer = PPOTrainer(config, model, model_ref, tokenizer, optimizer=optimizer, lr_scheduler=lr_scheduler)`}}),me=new J({}),ce=new K({props:{code:`import torch
from transformers import AutoTokenizer
from trl import PPOTrainer, PPOConfig, AutoModelForCausalLMWithValueHead, create_reference_model

# 1. load a pretrained model
model = AutoModelForCausalLMWithValueHead.from_pretrained('bigscience/bloom-560m')
model_ref = create_reference_model(model, num_shared_layers=6)
tokenizer = AutoTokenizer.from_pretrained('bigscience/bloom-560m')

# 2. initialize trainer
ppo_config = {'batch_size': 1}
config = PPOConfig(**ppo_config)
ppo_trainer = PPOTrainer(config, model, model_ref, tokenizer)`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer
<span class="hljs-keyword">from</span> trl <span class="hljs-keyword">import</span> PPOTrainer, PPOConfig, AutoModelForCausalLMWithValueHead, create_reference_model

<span class="hljs-comment"># 1. load a pretrained model</span>
model = AutoModelForCausalLMWithValueHead.from_pretrained(<span class="hljs-string">&#x27;bigscience/bloom-560m&#x27;</span>)
model_ref = create_reference_model(model, num_shared_layers=<span class="hljs-number">6</span>)
tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&#x27;bigscience/bloom-560m&#x27;</span>)

<span class="hljs-comment"># 2. initialize trainer</span>
ppo_config = {<span class="hljs-string">&#x27;batch_size&#x27;</span>: <span class="hljs-number">1</span>}
config = PPOConfig(**ppo_config)
ppo_trainer = PPOTrainer(config, model, model_ref, tokenizer)`}}),de=new J({}),he=new K({props:{code:`# 0. imports
# pip install bitsandbytes
import torch
from transformers import AutoTokenizer
from trl import PPOTrainer, PPOConfig, AutoModelForCausalLMWithValueHead

# 1. load a pretrained model
model = AutoModelForCausalLMWithValueHead.from_pretrained('bigscience/bloom-560m')
model_ref = AutoModelForCausalLMWithValueHead.from_pretrained('bigscience/bloom-560m', device_map="auto", load_in_8bit=True)
tokenizer = AutoTokenizer.from_pretrained('bigscience/bloom-560m')

# 2. initialize trainer
ppo_config = {'batch_size': 1}
config = PPOConfig(**ppo_config)
ppo_trainer = PPOTrainer(config, model, model_ref, tokenizer)`,highlighted:`<span class="hljs-comment"># 0. imports</span>
<span class="hljs-comment"># pip install bitsandbytes</span>
<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer
<span class="hljs-keyword">from</span> trl <span class="hljs-keyword">import</span> PPOTrainer, PPOConfig, AutoModelForCausalLMWithValueHead

<span class="hljs-comment"># 1. load a pretrained model</span>
model = AutoModelForCausalLMWithValueHead.from_pretrained(<span class="hljs-string">&#x27;bigscience/bloom-560m&#x27;</span>)
model_ref = AutoModelForCausalLMWithValueHead.from_pretrained(<span class="hljs-string">&#x27;bigscience/bloom-560m&#x27;</span>, device_map=<span class="hljs-string">&quot;auto&quot;</span>, load_in_8bit=<span class="hljs-literal">True</span>)
tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&#x27;bigscience/bloom-560m&#x27;</span>)

<span class="hljs-comment"># 2. initialize trainer</span>
ppo_config = {<span class="hljs-string">&#x27;batch_size&#x27;</span>: <span class="hljs-number">1</span>}
config = PPOConfig(**ppo_config)
ppo_trainer = PPOTrainer(config, model, model_ref, tokenizer)`}}),ue=new J({}),ge=new K({props:{code:"config = PPOConfig(..., optimize_cuda_cache=True)",highlighted:'config = PPOConfig(..., optimize_cuda_cache=<span class="hljs-literal">True</span>)'}}),_e=new J({}),ye=new K({props:{code:`ds_plugin = ppo_trainer.accelerator.state.deepspeed_plugin
if ds_plugin is not None and ds_plugin.is_zero3_init_enabled():
    with ds_plugin.zero3_init_context_manager(enable=False):
        sentiment_pipe = pipeline("sentiment-analysis", model="lvwerra/distilbert-imdb", device=device)
else:
    sentiment_pipe = pipeline("sentiment-analysis", model="lvwerra/distilbert-imdb", device=device)`,highlighted:`ds_plugin = ppo_trainer.accelerator.state.deepspeed_plugin
<span class="hljs-keyword">if</span> ds_plugin <span class="hljs-keyword">is</span> <span class="hljs-keyword">not</span> <span class="hljs-literal">None</span> <span class="hljs-keyword">and</span> ds_plugin.is_zero3_init_enabled():
    <span class="hljs-keyword">with</span> ds_plugin.zero3_init_context_manager(enable=<span class="hljs-literal">False</span>):
        sentiment_pipe = pipeline(<span class="hljs-string">&quot;sentiment-analysis&quot;</span>, model=<span class="hljs-string">&quot;lvwerra/distilbert-imdb&quot;</span>, device=device)
<span class="hljs-keyword">else</span>:
    sentiment_pipe = pipeline(<span class="hljs-string">&quot;sentiment-analysis&quot;</span>, model=<span class="hljs-string">&quot;lvwerra/distilbert-imdb&quot;</span>, device=device)`}}),{c(){A=a("meta"),sr=c(),E=a("h1"),W=a("a"),je=a("span"),f(Q.$$.fragment),qr=c(),Ae=a("span"),Ir=s("Training customization"),nr=c(),F=a("p"),Yr=s("At "),Ee=a("code"),Br=s("trl"),Rr=s(" we provide the possibility to give enough modularity to users to be able to efficiently customize the training loop for their needs. Below are some examples on how you can apply and test different techniques."),lr=c(),C=a("h2"),S=a("a"),Ce=a("span"),f(X.$$.fragment),Jr=c(),xe=a("span"),Kr=s("Use different optimizers"),pr=c(),b=a("p"),Qr=s("By default, the "),Oe=a("code"),Xr=s("PPOTrainer"),Zr=s(" creates a "),Te=a("code"),et=s("torch.optim.Adam"),rt=s(" optimizer. You can create and define a different optimizer and pass it to "),Me=a("code"),tt=s("PPOTrainer"),at=s(":"),mr=c(),f(Z.$$.fragment),cr=c(),w=a("p"),ot=s("For memory efficient fine-tuning, you can also pass "),Le=a("code"),it=s("Adam8bit"),st=s(" optimizer from "),He=a("code"),nt=s("bitsandbytes"),lt=s(":"),dr=c(),f(ee.$$.fragment),fr=c(),x=a("h3"),V=a("a"),De=a("span"),f(re.$$.fragment),pt=c(),We=a("span"),mt=s("Use LION optimizer"),hr=c(),$=a("p"),ct=s("You can use the new "),te=a("a"),dt=s("LION optimizer from Google"),ft=s(" as well, first take the source code of the optimizer definition "),ae=a("a"),ht=s("here"),ut=s(", and copy it so that you can import the optimizer. Make sure to initialize the optimizer by considering the trainable parameters only for a more memory efficient training:"),ur=c(),f(oe.$$.fragment),gr=c(),z=a("p"),gt=s("We advise you to use the learning rate that you would use for "),Fe=a("code"),_t=s("Adam"),yt=s(" divided by 3 as pointed out "),ie=a("a"),vt=s("here"),bt=s(". We observed an improvement when using this optimizer compared to classic Adam (check the full logs "),se=a("a"),zt=s("here"),Pt=s("):"),_r=c(),ne=a("div"),Se=a("img"),yr=c(),O=a("h2"),N=a("a"),Ve=a("span"),f(le.$$.fragment),wt=c(),Ne=a("span"),$t=s("Add a learning rate scheduler"),vr=c(),ve=a("p"),kt=s("You can also play with your training by adding learning rate schedulers!"),br=c(),f(pe.$$.fragment),zr=c(),T=a("h2"),G=a("a"),Ge=a("span"),f(me.$$.fragment),jt=c(),Ue=a("span"),At=s("Memory efficient fine-tuning by sharing layers"),Pr=c(),be=a("p"),Et=s("Another tool you can use for more memory efficient fine-tuning is to share layers between the reference model and the model you want to train."),wr=c(),f(ce.$$.fragment),$r=c(),M=a("h2"),U=a("a"),qe=a("span"),f(de.$$.fragment),Ct=c(),Ie=a("span"),xt=s("Pass 8-bit reference models"),kr=c(),q=a("div"),v=a("p"),Ot=s("Since "),Ye=a("code"),Tt=s("trl"),Mt=s(" supports all key word arguments when loading a model from "),Be=a("code"),Lt=s("transformers"),Ht=s(" using "),Re=a("code"),Dt=s("from_pretrained"),Wt=s(", you can also leverage "),Je=a("code"),Ft=s("load_in_8bit"),St=s(" from "),Ke=a("code"),Vt=s("transformers"),Nt=s(" for more memory efficient fine-tuning."),Gt=c(),L=a("p"),Ut=s("Read more about 8-bit model loading in "),Qe=a("code"),qt=s("transformers"),It=c(),fe=a("a"),Yt=s("here"),Bt=s("."),jr=c(),f(he.$$.fragment),Ar=c(),H=a("h2"),I=a("a"),Xe=a("span"),f(ue.$$.fragment),Rt=c(),Ze=a("span"),Jt=s("Use the CUDA cache optimizer"),Er=c(),k=a("p"),Kt=s("When training large models, you should better handle the CUDA cache by iteratively clearing it. Do do so, simply pass "),er=a("code"),Qt=s("optimize_cuda_cache=True"),Xt=s(" to "),rr=a("code"),Zt=s("PPOConfig"),ea=s(":"),Cr=c(),f(ge.$$.fragment),xr=c(),D=a("h2"),Y=a("a"),tr=a("span"),f(_e.$$.fragment),ra=c(),ar=a("span"),ta=s("Use correctly DeepSpeed stage 3:"),Or=c(),j=a("p"),aa=s("A small tweak need to be added to your training script to use DeepSpeed stage 3 correctly. You need to properly initialize your reward model on the correct device using the "),or=a("code"),oa=s("zero3_init_context_manager"),ia=s(" context manager. Here is an example adapted for the "),ir=a("code"),sa=s("gpt2-sentiment"),na=s(" script:"),Tr=c(),f(ye.$$.fragment),this.h()},l(e){const l=lo('[data-svelte="svelte-1phssyn"]',document.head);A=o(l,"META",{name:!0,content:!0}),l.forEach(t),sr=d(e),E=o(e,"H1",{class:!0});var Lr=i(E);W=o(Lr,"A",{id:!0,class:!0,href:!0});var ma=i(W);je=o(ma,"SPAN",{});var ca=i(je);h(Q.$$.fragment,ca),ca.forEach(t),ma.forEach(t),qr=d(Lr),Ae=o(Lr,"SPAN",{});var da=i(Ae);Ir=n(da,"Training customization"),da.forEach(t),Lr.forEach(t),nr=d(e),F=o(e,"P",{});var Hr=i(F);Yr=n(Hr,"At "),Ee=o(Hr,"CODE",{});var fa=i(Ee);Br=n(fa,"trl"),fa.forEach(t),Rr=n(Hr," we provide the possibility to give enough modularity to users to be able to efficiently customize the training loop for their needs. Below are some examples on how you can apply and test different techniques."),Hr.forEach(t),lr=d(e),C=o(e,"H2",{class:!0});var Dr=i(C);S=o(Dr,"A",{id:!0,class:!0,href:!0});var ha=i(S);Ce=o(ha,"SPAN",{});var ua=i(Ce);h(X.$$.fragment,ua),ua.forEach(t),ha.forEach(t),Jr=d(Dr),xe=o(Dr,"SPAN",{});var ga=i(xe);Kr=n(ga,"Use different optimizers"),ga.forEach(t),Dr.forEach(t),pr=d(e),b=o(e,"P",{});var B=i(b);Qr=n(B,"By default, the "),Oe=o(B,"CODE",{});var _a=i(Oe);Xr=n(_a,"PPOTrainer"),_a.forEach(t),Zr=n(B," creates a "),Te=o(B,"CODE",{});var ya=i(Te);et=n(ya,"torch.optim.Adam"),ya.forEach(t),rt=n(B," optimizer. You can create and define a different optimizer and pass it to "),Me=o(B,"CODE",{});var va=i(Me);tt=n(va,"PPOTrainer"),va.forEach(t),at=n(B,":"),B.forEach(t),mr=d(e),h(Z.$$.fragment,e),cr=d(e),w=o(e,"P",{});var ze=i(w);ot=n(ze,"For memory efficient fine-tuning, you can also pass "),Le=o(ze,"CODE",{});var ba=i(Le);it=n(ba,"Adam8bit"),ba.forEach(t),st=n(ze," optimizer from "),He=o(ze,"CODE",{});var za=i(He);nt=n(za,"bitsandbytes"),za.forEach(t),lt=n(ze,":"),ze.forEach(t),dr=d(e),h(ee.$$.fragment,e),fr=d(e),x=o(e,"H3",{class:!0});var Wr=i(x);V=o(Wr,"A",{id:!0,class:!0,href:!0});var Pa=i(V);De=o(Pa,"SPAN",{});var wa=i(De);h(re.$$.fragment,wa),wa.forEach(t),Pa.forEach(t),pt=d(Wr),We=o(Wr,"SPAN",{});var $a=i(We);mt=n($a,"Use LION optimizer"),$a.forEach(t),Wr.forEach(t),hr=d(e),$=o(e,"P",{});var Pe=i($);ct=n(Pe,"You can use the new "),te=o(Pe,"A",{href:!0,rel:!0});var ka=i(te);dt=n(ka,"LION optimizer from Google"),ka.forEach(t),ft=n(Pe," as well, first take the source code of the optimizer definition "),ae=o(Pe,"A",{href:!0,rel:!0});var ja=i(ae);ht=n(ja,"here"),ja.forEach(t),ut=n(Pe,", and copy it so that you can import the optimizer. Make sure to initialize the optimizer by considering the trainable parameters only for a more memory efficient training:"),Pe.forEach(t),ur=d(e),h(oe.$$.fragment,e),gr=d(e),z=o(e,"P",{});var R=i(z);gt=n(R,"We advise you to use the learning rate that you would use for "),Fe=o(R,"CODE",{});var Aa=i(Fe);_t=n(Aa,"Adam"),Aa.forEach(t),yt=n(R," divided by 3 as pointed out "),ie=o(R,"A",{href:!0,rel:!0});var Ea=i(ie);vt=n(Ea,"here"),Ea.forEach(t),bt=n(R,". We observed an improvement when using this optimizer compared to classic Adam (check the full logs "),se=o(R,"A",{href:!0,rel:!0});var Ca=i(se);zt=n(Ca,"here"),Ca.forEach(t),Pt=n(R,"):"),R.forEach(t),_r=d(e),ne=o(e,"DIV",{style:!0});var xa=i(ne);Se=o(xa,"IMG",{src:!0}),xa.forEach(t),yr=d(e),O=o(e,"H2",{class:!0});var Fr=i(O);N=o(Fr,"A",{id:!0,class:!0,href:!0});var Oa=i(N);Ve=o(Oa,"SPAN",{});var Ta=i(Ve);h(le.$$.fragment,Ta),Ta.forEach(t),Oa.forEach(t),wt=d(Fr),Ne=o(Fr,"SPAN",{});var Ma=i(Ne);$t=n(Ma,"Add a learning rate scheduler"),Ma.forEach(t),Fr.forEach(t),vr=d(e),ve=o(e,"P",{});var La=i(ve);kt=n(La,"You can also play with your training by adding learning rate schedulers!"),La.forEach(t),br=d(e),h(pe.$$.fragment,e),zr=d(e),T=o(e,"H2",{class:!0});var Sr=i(T);G=o(Sr,"A",{id:!0,class:!0,href:!0});var Ha=i(G);Ge=o(Ha,"SPAN",{});var Da=i(Ge);h(me.$$.fragment,Da),Da.forEach(t),Ha.forEach(t),jt=d(Sr),Ue=o(Sr,"SPAN",{});var Wa=i(Ue);At=n(Wa,"Memory efficient fine-tuning by sharing layers"),Wa.forEach(t),Sr.forEach(t),Pr=d(e),be=o(e,"P",{});var Fa=i(be);Et=n(Fa,"Another tool you can use for more memory efficient fine-tuning is to share layers between the reference model and the model you want to train."),Fa.forEach(t),wr=d(e),h(ce.$$.fragment,e),$r=d(e),M=o(e,"H2",{class:!0});var Vr=i(M);U=o(Vr,"A",{id:!0,class:!0,href:!0});var Sa=i(U);qe=o(Sa,"SPAN",{});var Va=i(qe);h(de.$$.fragment,Va),Va.forEach(t),Sa.forEach(t),Ct=d(Vr),Ie=o(Vr,"SPAN",{});var Na=i(Ie);xt=n(Na,"Pass 8-bit reference models"),Na.forEach(t),Vr.forEach(t),kr=d(e),q=o(e,"DIV",{});var Nr=i(q);v=o(Nr,"P",{});var P=i(v);Ot=n(P,"Since "),Ye=o(P,"CODE",{});var Ga=i(Ye);Tt=n(Ga,"trl"),Ga.forEach(t),Mt=n(P," supports all key word arguments when loading a model from "),Be=o(P,"CODE",{});var Ua=i(Be);Lt=n(Ua,"transformers"),Ua.forEach(t),Ht=n(P," using "),Re=o(P,"CODE",{});var qa=i(Re);Dt=n(qa,"from_pretrained"),qa.forEach(t),Wt=n(P,", you can also leverage "),Je=o(P,"CODE",{});var Ia=i(Je);Ft=n(Ia,"load_in_8bit"),Ia.forEach(t),St=n(P," from "),Ke=o(P,"CODE",{});var Ya=i(Ke);Vt=n(Ya,"transformers"),Ya.forEach(t),Nt=n(P," for more memory efficient fine-tuning."),P.forEach(t),Gt=d(Nr),L=o(Nr,"P",{});var we=i(L);Ut=n(we,"Read more about 8-bit model loading in "),Qe=o(we,"CODE",{});var Ba=i(Qe);qt=n(Ba,"transformers"),Ba.forEach(t),It=d(we),fe=o(we,"A",{href:!0,rel:!0});var Ra=i(fe);Yt=n(Ra,"here"),Ra.forEach(t),Bt=n(we,"."),we.forEach(t),Nr.forEach(t),jr=d(e),h(he.$$.fragment,e),Ar=d(e),H=o(e,"H2",{class:!0});var Gr=i(H);I=o(Gr,"A",{id:!0,class:!0,href:!0});var Ja=i(I);Xe=o(Ja,"SPAN",{});var Ka=i(Xe);h(ue.$$.fragment,Ka),Ka.forEach(t),Ja.forEach(t),Rt=d(Gr),Ze=o(Gr,"SPAN",{});var Qa=i(Ze);Jt=n(Qa,"Use the CUDA cache optimizer"),Qa.forEach(t),Gr.forEach(t),Er=d(e),k=o(e,"P",{});var $e=i(k);Kt=n($e,"When training large models, you should better handle the CUDA cache by iteratively clearing it. Do do so, simply pass "),er=o($e,"CODE",{});var Xa=i(er);Qt=n(Xa,"optimize_cuda_cache=True"),Xa.forEach(t),Xt=n($e," to "),rr=o($e,"CODE",{});var Za=i(rr);Zt=n(Za,"PPOConfig"),Za.forEach(t),ea=n($e,":"),$e.forEach(t),Cr=d(e),h(ge.$$.fragment,e),xr=d(e),D=o(e,"H2",{class:!0});var Ur=i(D);Y=o(Ur,"A",{id:!0,class:!0,href:!0});var eo=i(Y);tr=o(eo,"SPAN",{});var ro=i(tr);h(_e.$$.fragment,ro),ro.forEach(t),eo.forEach(t),ra=d(Ur),ar=o(Ur,"SPAN",{});var to=i(ar);ta=n(to,"Use correctly DeepSpeed stage 3:"),to.forEach(t),Ur.forEach(t),Or=d(e),j=o(e,"P",{});var ke=i(j);aa=n(ke,"A small tweak need to be added to your training script to use DeepSpeed stage 3 correctly. You need to properly initialize your reward model on the correct device using the "),or=o(ke,"CODE",{});var ao=i(or);oa=n(ao,"zero3_init_context_manager"),ao.forEach(t),ia=n(ke," context manager. Here is an example adapted for the "),ir=o(ke,"CODE",{});var oo=i(ir);sa=n(oo,"gpt2-sentiment"),oo.forEach(t),na=n(ke," script:"),ke.forEach(t),Tr=d(e),h(ye.$$.fragment,e),this.h()},h(){m(A,"name","hf:doc:metadata"),m(A,"content",JSON.stringify(uo)),m(W,"id","training-customization"),m(W,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(W,"href","#training-customization"),m(E,"class","relative group"),m(S,"id","use-different-optimizers"),m(S,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(S,"href","#use-different-optimizers"),m(C,"class","relative group"),m(V,"id","use-lion-optimizer"),m(V,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(V,"href","#use-lion-optimizer"),m(x,"class","relative group"),m(te,"href","https://arxiv.org/abs/2302.06675"),m(te,"rel","nofollow"),m(ae,"href","https://github.com/lucidrains/lion-pytorch/blob/main/lion_pytorch/lion_pytorch.py"),m(ae,"rel","nofollow"),m(ie,"href","https://github.com/lucidrains/lion-pytorch#lion---pytorch"),m(ie,"rel","nofollow"),m(se,"href","https://wandb.ai/distill-bloom/trl/runs/lj4bheke?workspace=user-younesbelkada"),m(se,"rel","nofollow"),po(Se.src,pa="https://huggingface.co/datasets/trl-internal-testing/example-images/resolve/main/images/trl-lion.png")||m(Se,"src",pa),mo(ne,"text-align","center"),m(N,"id","add-a-learning-rate-scheduler"),m(N,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(N,"href","#add-a-learning-rate-scheduler"),m(O,"class","relative group"),m(G,"id","memory-efficient-finetuning-by-sharing-layers"),m(G,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(G,"href","#memory-efficient-finetuning-by-sharing-layers"),m(T,"class","relative group"),m(U,"id","pass-8bit-reference-models"),m(U,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(U,"href","#pass-8bit-reference-models"),m(M,"class","relative group"),m(fe,"href","https://huggingface.co/docs/transformers/perf_infer_gpu_one#bitsandbytes-integration-for-int8-mixedprecision-matrix-decomposition"),m(fe,"rel","nofollow"),m(I,"id","use-the-cuda-cache-optimizer"),m(I,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(I,"href","#use-the-cuda-cache-optimizer"),m(H,"class","relative group"),m(Y,"id","use-correctly-deepspeed-stage-3"),m(Y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),m(Y,"href","#use-correctly-deepspeed-stage-3"),m(D,"class","relative group")},m(e,l){r(document.head,A),p(e,sr,l),p(e,E,l),r(E,W),r(W,je),u(Q,je,null),r(E,qr),r(E,Ae),r(Ae,Ir),p(e,nr,l),p(e,F,l),r(F,Yr),r(F,Ee),r(Ee,Br),r(F,Rr),p(e,lr,l),p(e,C,l),r(C,S),r(S,Ce),u(X,Ce,null),r(C,Jr),r(C,xe),r(xe,Kr),p(e,pr,l),p(e,b,l),r(b,Qr),r(b,Oe),r(Oe,Xr),r(b,Zr),r(b,Te),r(Te,et),r(b,rt),r(b,Me),r(Me,tt),r(b,at),p(e,mr,l),u(Z,e,l),p(e,cr,l),p(e,w,l),r(w,ot),r(w,Le),r(Le,it),r(w,st),r(w,He),r(He,nt),r(w,lt),p(e,dr,l),u(ee,e,l),p(e,fr,l),p(e,x,l),r(x,V),r(V,De),u(re,De,null),r(x,pt),r(x,We),r(We,mt),p(e,hr,l),p(e,$,l),r($,ct),r($,te),r(te,dt),r($,ft),r($,ae),r(ae,ht),r($,ut),p(e,ur,l),u(oe,e,l),p(e,gr,l),p(e,z,l),r(z,gt),r(z,Fe),r(Fe,_t),r(z,yt),r(z,ie),r(ie,vt),r(z,bt),r(z,se),r(se,zt),r(z,Pt),p(e,_r,l),p(e,ne,l),r(ne,Se),p(e,yr,l),p(e,O,l),r(O,N),r(N,Ve),u(le,Ve,null),r(O,wt),r(O,Ne),r(Ne,$t),p(e,vr,l),p(e,ve,l),r(ve,kt),p(e,br,l),u(pe,e,l),p(e,zr,l),p(e,T,l),r(T,G),r(G,Ge),u(me,Ge,null),r(T,jt),r(T,Ue),r(Ue,At),p(e,Pr,l),p(e,be,l),r(be,Et),p(e,wr,l),u(ce,e,l),p(e,$r,l),p(e,M,l),r(M,U),r(U,qe),u(de,qe,null),r(M,Ct),r(M,Ie),r(Ie,xt),p(e,kr,l),p(e,q,l),r(q,v),r(v,Ot),r(v,Ye),r(Ye,Tt),r(v,Mt),r(v,Be),r(Be,Lt),r(v,Ht),r(v,Re),r(Re,Dt),r(v,Wt),r(v,Je),r(Je,Ft),r(v,St),r(v,Ke),r(Ke,Vt),r(v,Nt),r(q,Gt),r(q,L),r(L,Ut),r(L,Qe),r(Qe,qt),r(L,It),r(L,fe),r(fe,Yt),r(L,Bt),p(e,jr,l),u(he,e,l),p(e,Ar,l),p(e,H,l),r(H,I),r(I,Xe),u(ue,Xe,null),r(H,Rt),r(H,Ze),r(Ze,Jt),p(e,Er,l),p(e,k,l),r(k,Kt),r(k,er),r(er,Qt),r(k,Xt),r(k,rr),r(rr,Zt),r(k,ea),p(e,Cr,l),u(ge,e,l),p(e,xr,l),p(e,D,l),r(D,Y),r(Y,tr),u(_e,tr,null),r(D,ra),r(D,ar),r(ar,ta),p(e,Or,l),p(e,j,l),r(j,aa),r(j,or),r(or,oa),r(j,ia),r(j,ir),r(ir,sa),r(j,na),p(e,Tr,l),u(ye,e,l),Mr=!0},p:co,i(e){Mr||(g(Q.$$.fragment,e),g(X.$$.fragment,e),g(Z.$$.fragment,e),g(ee.$$.fragment,e),g(re.$$.fragment,e),g(oe.$$.fragment,e),g(le.$$.fragment,e),g(pe.$$.fragment,e),g(me.$$.fragment,e),g(ce.$$.fragment,e),g(de.$$.fragment,e),g(he.$$.fragment,e),g(ue.$$.fragment,e),g(ge.$$.fragment,e),g(_e.$$.fragment,e),g(ye.$$.fragment,e),Mr=!0)},o(e){_(Q.$$.fragment,e),_(X.$$.fragment,e),_(Z.$$.fragment,e),_(ee.$$.fragment,e),_(re.$$.fragment,e),_(oe.$$.fragment,e),_(le.$$.fragment,e),_(pe.$$.fragment,e),_(me.$$.fragment,e),_(ce.$$.fragment,e),_(de.$$.fragment,e),_(he.$$.fragment,e),_(ue.$$.fragment,e),_(ge.$$.fragment,e),_(_e.$$.fragment,e),_(ye.$$.fragment,e),Mr=!1},d(e){t(A),e&&t(sr),e&&t(E),y(Q),e&&t(nr),e&&t(F),e&&t(lr),e&&t(C),y(X),e&&t(pr),e&&t(b),e&&t(mr),y(Z,e),e&&t(cr),e&&t(w),e&&t(dr),y(ee,e),e&&t(fr),e&&t(x),y(re),e&&t(hr),e&&t($),e&&t(ur),y(oe,e),e&&t(gr),e&&t(z),e&&t(_r),e&&t(ne),e&&t(yr),e&&t(O),y(le),e&&t(vr),e&&t(ve),e&&t(br),y(pe,e),e&&t(zr),e&&t(T),y(me),e&&t(Pr),e&&t(be),e&&t(wr),y(ce,e),e&&t($r),e&&t(M),y(de),e&&t(kr),e&&t(q),e&&t(jr),y(he,e),e&&t(Ar),e&&t(H),y(ue),e&&t(Er),e&&t(k),e&&t(Cr),y(ge,e),e&&t(xr),e&&t(D),y(_e),e&&t(Or),e&&t(j),e&&t(Tr),y(ye,e)}}}const uo={local:"training-customization",sections:[{local:"use-different-optimizers",sections:[{local:"use-lion-optimizer",title:"Use LION optimizer"}],title:"Use different optimizers"},{local:"add-a-learning-rate-scheduler",title:"Add a learning rate scheduler"},{local:"memory-efficient-finetuning-by-sharing-layers",title:"Memory efficient fine-tuning by sharing layers"},{local:"pass-8bit-reference-models",title:"Pass 8-bit reference models "},{local:"use-the-cuda-cache-optimizer",title:"Use the CUDA cache optimizer"},{local:"use-correctly-deepspeed-stage-3",title:"Use correctly DeepSpeed stage 3:"}],title:"Training customization"};function go(la){return fo(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class bo extends io{constructor(A){super();so(this,A,go,ho,no,{})}}export{bo as default,uo as metadata};
